SystemOrganization addCategory: #'EyeSee-Axis'!

Object subclass: #ESAbstractAxis
	instanceVariableNames: 'preferedMaxValue preferedMinValue maxValue minValue values start end label color labelRepresentation rotatedLabels normalLabelOrientation labelDistanceBlock labelPointCalculationBlock textStyle gridLineLenght'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESAbstractAxis methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
calculatePoint: aNumber
	
	^self end scaledBy: aNumber * self scaleFactor / self length! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color
	
	^color! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color: anObject
	
	color := anObject! !

!ESAbstractAxis methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
end
	
	^end! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
end: anObject
	
	end := anObject! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: 'AndreHora 12/4/2011 18:55'!
fontSize

	self textStyle isNil
		ifTrue: [^0]
		ifFalse: [^self textStyle defaultFont pointSize]
		! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
from: aPoint to: aPoint2
	
	self start: aPoint.
	self end: aPoint2! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ 0! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
getOrientationScaleFactor
	
	self normalLabelOrientation
		ifTrue: [^-1]
		ifFalse: [^1]! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
getOriginalValues
	
	^self values! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gridLineLenght: aNumber
	
	gridLineLenght := aNumber! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
height
	
	^0! !

!ESAbstractAxis methodsFor: 'initialize-release' stamp: 'AndreHora 4/6/2011 16:07'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	self rotatedLabels: false.
	self normalLabelOrientation: false.
	self labelDistanceBlock: [:each | 15].
	self labelRepresentation: [:each | each].	"	[:each | 
			each isFraction ifTrue: [each asFloat roundTo: 0.01] ifFalse: [each]]."	"		fd := (FontDescription new)
				family: #('bookman' 'times*' '*');
				serif: false;
				fixedWidth: false;
				pixelSize: (10 * (96/72) asFloat) rounded.
	ca := CharacterAttributes newWithDefaultAttributes.
	ca setDefaultQuery: fd.
	ta := TextAttributes characterAttributes: ca."	"self labelPointCalculationBlock: 
			[:aPoint :aLabel | 
			| length shorterLength |
			length := 0 asPoint dist: aPoint.
			shorterLength := length - 6.	6 is half of a default font size
			aPoint scaledBy: shorterLength / length]."
	^self! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
label
	
	^label! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
label: anObject
	
	label := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceBlock
	
	^labelDistanceBlock! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceBlock: anObject
	
	labelDistanceBlock := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	"label distance from axis is 0 as long as the axis doesn't have labels"
	
	^0! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelPointCalculationBlock
	
	^labelPointCalculationBlock! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelPointCalculationBlock: anObject
	
	labelPointCalculationBlock := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: anObject
	
	labelRepresentation := anObject! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
length
	
	^self start dist: self end! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
maxValue
	
	self preferedMaxValue isNil
		ifTrue: [^maxValue]
		ifFalse: [^self preferedMaxValue]! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
maxValue: anObject
	
	maxValue := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minValue
	
	^minValue! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minValue: anObject
	
	minValue := anObject! !

!ESAbstractAxis methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
moveBy: aPoint
	
	self start: self start + aPoint.
	self end: self end + aPoint! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
normalLabelOrientation
	
	^normalLabelOrientation! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
normalLabelOrientation: anObject
	
	normalLabelOrientation := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMaxValue
	
	^preferedMaxValue! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMaxValue: anObject
	
	preferedMaxValue := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMinValue
	
	^preferedMinValue! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMinValue: anObject
	
	preferedMinValue := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels
	
	^rotatedLabels! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels: anObject
	
	rotatedLabels := anObject! !

!ESAbstractAxis methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
scaleFactor
	
	self maxValue - self minValue = 0 ifTrue: [^0].
	^self length asFloat / (self maxValue - self minValue)! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setPositions
	
	! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setStart: aPoint setEnd: aPoint2
	
	self start: aPoint.
	self end: aPoint2! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
start
	
	^start! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
start: anObject
	
	start := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle
	
	^textStyle! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle: anObject
	
	textStyle := anObject! !

!ESAbstractAxis methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
values
	
	^values! !

!ESAbstractAxis methodsFor: 'accessing' stamp: 'AndreHora 6/6/2012 17:27'!
values: aCollection

	values := aCollection
		collect: [:each | 

			(ESTextDataObject new)
				rotated: self rotatedLabels;
				text: each asString;
				textStyle: self textStyle;
				model: each;
				color: self color]! !

ESAbstractAxis subclass: #ESAbstractAxisDecorator
	instanceVariableNames: 'anAxis minTickDistance centerIdentifiers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESAbstractAxisDecorator classSide methodsFor: 'instance creation' stamp: 'AndreHora 4/1/2011 16:19'!
newWith: anAbstractAxis
	
	^ self new anAxis: anAbstractAxis! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
anAxis
	
	^anAxis! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
anAxis: anObject
	
	anAxis := anObject! !

!ESAbstractAxisDecorator methodsFor: 'private' stamp: 'AndreHora 3/11/2011 18:01'!
calculateNormalVectorAt: aPoint ofLenght: aLength
	"This will return the normal vector starting in aPoint of the length aLength and in the direction that is set by the orientation insance variable"
	
	| temp distance |
	(aPoint x < 0 or: [aPoint y < 0])
		ifTrue: [temp := aPoint rotateBy: (Float pi) / 2 negated]
		ifFalse: [temp := aPoint rotateBy: (Float pi) / 2].
	distance := aPoint dist: temp + aPoint.
	distance = 0 ifTrue: [^aPoint].
	temp := temp * (aLength / distance).
	^aPoint + temp! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
calculatePoint: aNumber
	
	^self anAxis calculatePoint: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: 'AndreHora 6/3/2011 12:27'!
calculatePositionFor: aLabel at: aPoint
	
	| labelPoint distance labelString |
	labelString := self labelRepresentation value: aLabel.
	labelPoint := self getLabelPoint: aPoint labelString: labelString.
	
	"distance := self getDistanceToAxis: labelString."
	
	(labelString isString)
		ifTrue: [ distance := self getDistanceToAxis: labelString asString asMorph ]
		ifFalse: [ distance := self getDistanceToAxis: labelString asString asMorph ].
	
	labelPoint := self calculateNormalVectorAt: labelPoint ofLenght: distance.
	^labelPoint! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
centerIdentifiers
	
	^centerIdentifiers! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
centerIdentifiers: anObject
	
	centerIdentifiers := anObject! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color
	
	^anAxis color! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
color: aColor
	
	^anAxis color: aColor! !

!ESAbstractAxisDecorator methodsFor: 'copying' stamp: ' 11/3/11 16:41'!
copy
	
	^super copy anAxis: self anAxis copy! !

!ESAbstractAxisDecorator methodsFor: 'displaying' stamp: 'AndreHora 6/6/2011 11:30'!
displayLabelAt: aPoint value: aNumber on: aGraphicsContext
	
	| labelPoint distance labelString |

	labelString := self labelRepresentation value: aNumber.
	"labelPoint := self getLabelPoint: aPoint labelString: labelString."
	"distance := self getDistanceToAxis: labelString."
	"added the if statmt"
	(labelString isNumber or: [labelString isString])
		ifTrue: [ labelPoint := self getLabelPoint: aPoint labelString: labelString asString asMorph.
				distance := self getDistanceToAxis: labelString asString asMorph. ]
		ifFalse: [ labelPoint := self getLabelPoint: aPoint labelString: labelString.
				distance := self getDistanceToAxis: labelString ].
			
	labelPoint := self calculateNormalVectorAt: labelPoint ofLenght: distance.
	self rotatedLabels
		ifTrue:
			[ aGraphicsContext 
				displayRotatedString: labelString asString
				at: labelPoint 
				angle: 90 "TODO"]
		ifFalse:
			[ aGraphicsContext 
				displayString: labelString asString
				at: labelPoint]! !

!ESAbstractAxisDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	self isLabelDecorator ifTrue: [self setPositions].
	self anAxis displayOn: aGraphicsContext! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
end
	
	^self anAxis end! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
end: aPoint
	
	self anAxis end: aPoint! !

!ESAbstractAxisDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/29/2011 11:07'!
getDistanceToAxis: aString
	
	^(self labelDistanceBlock value: aString) * self getOrientationScaleFactor! !

!ESAbstractAxisDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
getLabelPoint: aPoint labelString: aString
	
	| labelPoint |
	aPoint = 0 asPoint
		ifTrue: [labelPoint := self end scaledBy: 1.0 / 10000]
		ifFalse: [labelPoint := aPoint].	"if aPoint is 0@0, the normal vector can't be calculated, so 
		we use a point which is close to 0@0 in the direction of the axis"
	^self labelPointCalculationBlock value: labelPoint value: aString! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ self anAxis getMaxLenghtOfLabel! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
getOrientationScaleFactor
	
	^self anAxis getOrientationScaleFactor! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
getOriginalValues
	
	^self anAxis getOriginalValues! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gridLineLenght: aNumber
	
	self anAxis gridLineLenght: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 19:08'!
height
	
	| maxStringHeight |

	self values ifNil: [^0].
	maxStringHeight := self values getMaxStringHeight.
	^ self labelDistanceFromAxis + maxStringHeight! !

!ESAbstractAxisDecorator methodsFor: 'initialize-release' stamp: 'TudorGirba 4/17/2011 23:30'!
initialize
"explicitly do not call the super initialize - do not know why -- doru"
	self minTickDistance: 15.
	self centerIdentifiers: true! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^false! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
label
	
	^self anAxis label! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
label: aString
	
	self anAxis label: aString! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceBlock
	
	^self anAxis labelDistanceBlock! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceBlock: aBlock
	
	self anAxis labelDistanceBlock: aBlock! !

!ESAbstractAxisDecorator methodsFor: 'evaluating' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self anAxis labelDistanceFromAxis! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelPointCalculationBlock
	
	^self anAxis labelPointCalculationBlock! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:55'!
labelPointCalculationBlock: aBlock
	
	^self anAxis labelPointCalculationBlock: aBlock! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^self anAxis labelRepresentation! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	self anAxis labelRepresentation: aBlock! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
length
	
	^self anAxis length! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
maxValue
	
	^self anAxis maxValue! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: 'AndreHora 4/5/2011 11:36'!
maxValue: aNumber
	
	self anAxis maxValue: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minTickDistance
	
	^minTickDistance! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minTickDistance: anObject
	
	minTickDistance := anObject! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minValue
	
	^self anAxis minValue! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
minValue: aNumber
	
	self anAxis minValue: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'changing' stamp: ' 11/3/11 16:41'!
moveBy: aPoint
	
	self anAxis moveBy: aPoint! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMaxValue
	
	^self anAxis preferedMaxValue! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMaxValue: aNumber
	
	^self anAxis preferedMaxValue: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMinValue
	
	^self anAxis preferedMinValue! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
preferedMinValue: aNumber
	
	^self anAxis preferedMinValue: aNumber! !

!ESAbstractAxisDecorator methodsFor: 'private' stamp: ' 11/3/11 16:41'!
resize: aNumber
	
	aNumber > 1000000
		| (aNumber < 0.000001 & (aNumber > 0) | (aNumber < -1000000))
		ifTrue: [^aNumber asFloat].
	aNumber isInteger ifFalse: [^aNumber asFloat].	"TODO: check if aNumber has too many numbers after coma"
	^aNumber! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels
	
	^self anAxis rotatedLabels! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
rotatedLabels: aBoolean
	
	self anAxis rotatedLabels: aBoolean! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scaleFactor
	
	^self anAxis scaleFactor! !

!ESAbstractAxisDecorator methodsFor: 'private' stamp: 'AndreHora 3/25/2011 16:13'!
setPositions
	
	| currPoint |
	self values
		do:
			[:each | 
			currPoint := self calculatePoint: each model.
			each position: (self calculatePositionFor: each at: currPoint)]! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
setStart: aPoint setEnd: aPoint2
	
	self anAxis setStart: aPoint setEnd: aPoint2! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
start
	
	^self anAxis start! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
start: anObject
	
	self anAxis start: anObject! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle
	
	^self anAxis textStyle! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
textStyle: aTextStyle
	
	self anAxis textStyle: aTextStyle! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
values
	
	^self anAxis values! !

!ESAbstractAxisDecorator methodsFor: 'accessing' stamp: 'AndreHora 3/25/2011 16:53'!
values: aCollection
	
	self anAxis values: aCollection! !

ESAbstractAxisDecorator subclass: #ESAbstractRegularDecorator
	instanceVariableNames: 'stepSize cachedMax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESAbstractRegularDecorator methodsFor: 'private' stamp: 'ChrisCunningham 8/1/2012 21:06'!
adjustStepSize
	
	| n |
	self flag: 'strange super send'.

	(self getOriginalValues isNil not
		and: [self getOriginalValues maxValue = 0]) ifTrue: [^0].
	self end notNil
		ifTrue:
			[self stepSize: (10 raisedTo: self getOriginalValues maxValue value log rounded).
			n := 0.
			[self getOriginalValues maxValue value > n]
				whileTrue: [n := n + self stepSize].
			super maxValue: n.
			[self tickDistance >= (2 * self minTickDistance)
				and: [(self stepSize quo: 5) even]]
				whileTrue:
					[self stepSize: self stepSize / 2.
					n := 0.
					[self getOriginalValues maxValue value > n]
						whileTrue: [n := n + self stepSize]]]
		ifFalse: [n := super maxValue].
	[(n max: (self preferedMaxValue ifNil: [n])) / self stepSize < 5] whileTrue: [stepSize := stepSize / 2].
	^n! !

!ESAbstractRegularDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayDecorationOn: aGraphicsContext
	
	! !

!ESAbstractRegularDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/6/2011 22:07'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self displayDecorationOn: aGraphicsContext! !

!ESAbstractRegularDecorator methodsFor: 'private' stamp: ' 11/3/11 16:41'!
drawTickAt: aPoint on: aGraphicsContext
	
	self subclassResponsibility! !

!ESAbstractRegularDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self stepSize: 1.
	^self! !

!ESAbstractRegularDecorator methodsFor: 'accessing' stamp: 'AndreHora 5/15/2012 10:52'!
maxValue
	self flag: 'strange super send'.
	self preferedMaxValue 
		ifNotNil: [
			self adjustStepSize.
			^ self preferedMaxValue].
	cachedMax isNil 
		ifTrue: [cachedMax := self adjustStepSize].
	super maxValue: cachedMax.
	^ super maxValue! !

!ESAbstractRegularDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
scaleFactor
	
	self maxValue - self minValue = 0 ifTrue: [^0].
	^self length asFloat / (self maxValue - self minValue)! !

!ESAbstractRegularDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
stepSize
	
	^stepSize! !

!ESAbstractRegularDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
stepSize: anInteger
	
	[anInteger ~= 0] assert.
	stepSize := anInteger! !

!ESAbstractRegularDecorator methodsFor: 'private' stamp: 'TudorGirba 4/17/2011 21:13'!
tickCount
	self flag: 'strange super send'.
	self getOriginalValues isEmpty ifTrue: [^0].
	^(super maxValue - super minValue) / self stepSize! !

!ESAbstractRegularDecorator methodsFor: 'private' stamp: ' 11/3/11 16:41'!
tickDistance
	
	self tickCount = 0 ifTrue: [^0].
	^self length / self tickCount! !

!ESAbstractRegularDecorator methodsFor: 'accessing' stamp: 'AndreHora 10/5/2012 16:19'!
values
	
	values
		ifNil:
			[values := OrderedCollection new.
			0
				to: self tickCount
				do: [:n | values add: (ESTextDataObject new model: (n * self stepSize) asTruncatedFloat)]].
	^values! !

ESAbstractRegularDecorator subclass: #ESRegularGridLineDecorator
	instanceVariableNames: 'gridLineLength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESRegularGridLineDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayDecorationOn: aGraphicsContext
	
	super displayDecorationOn: aGraphicsContext.
	0
		to: self tickCount
		do:
			[:num | 
			| currPoint |
			currPoint := self end scaledBy: num * self tickDistance / self length.
			self
				drawOverlapingTickAt: currPoint
				on: aGraphicsContext
				ofLength: self gridLineLenght]! !

!ESRegularGridLineDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/11/2011 18:05'!
drawOverlapingTickAt: aPoint on: aGraphicsContext ofLength: aNumber
	
	| endPoint tick |
	endPoint := self
		calculateNormalVectorAt: aPoint
		ofLenght: aNumber negated.
	tick := LineSegment from: aPoint to: endPoint.
	tick displayStrokedOn: (aGraphicsContext paint: Color white)! !

!ESRegularGridLineDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gridLineLenght
	
	^gridLineLength! !

!ESRegularGridLineDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
gridLineLenght: anObject
	
	gridLineLength := anObject! !

!ESRegularGridLineDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self gridLineLenght: 300.
	^self! !

ESAbstractRegularDecorator subclass: #ESRegularLabelDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESRegularLabelDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/6/2011 22:10'!
displayDecorationOn: aGraphicsContext
	
	super displayDecorationOn: aGraphicsContext.
	self values do: [:each | each displayOn: aGraphicsContext]! !

!ESRegularLabelDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel

	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLengthForFont: self textStyle defaultFont! !

!ESRegularLabelDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotatedLabels := false.
	^self! !

!ESRegularLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^true! !

!ESRegularLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self fontSize! !

!ESRegularLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESRegularLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	labelRepresentation := aBlock.
	super labelRepresentation: aBlock! !

ESAbstractRegularDecorator subclass: #ESRegularTickDecorator
	instanceVariableNames: 'tickWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESRegularTickDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayDecorationOn: aGraphicsContext
	
	super displayDecorationOn: aGraphicsContext.
	0
		to: self tickCount
		do:
			[:num | 
			| currPoint |
			currPoint := self end scaledBy: num * self tickDistance / self length.
			self drawTickAt: currPoint on: aGraphicsContext]! !

!ESRegularTickDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/28/2011 10:50'!
drawTickAt: aPoint on: aGraphicsContext
	
	| startPoint endPoint |
	endPoint := aPoint.
	startPoint := self
		calculateNormalVectorAt: aPoint
		ofLenght: self tickWidth.
	(LineSegment from: startPoint to: endPoint)
		displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESRegularTickDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self tickWidth: 4.
	^self! !

!ESRegularTickDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickWidth
	
	^tickWidth! !

!ESRegularTickDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickWidth: anObject
	
	tickWidth := anObject! !

ESAbstractAxisDecorator subclass: #ESBaseLineDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESBaseLineDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self drawBaseLine: aGraphicsContext! !

!ESBaseLineDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/28/2011 10:50'!
drawBaseLine: aGraphicsContext
	
	| line |
	line := LineSegment
		from: self start
		to: self end.
	line displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESBaseLineDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	^self! !

ESAbstractAxisDecorator subclass: #ESBoxPlotLabelDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESBoxPlotLabelDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/25/2011 17:16'!
displayOn: aGraphicsContext
	
	| min max |
	super displayOn: aGraphicsContext.
	min := self values minValue value - self minValue.
	max := self values maxValue value - self minValue.
	self
		displayLabelAt: (self calculatePoint: min)
		value: self values minValue
		on: (aGraphicsContext paint: self color).
	self
		displayLabelAt: (self calculatePoint: max)
		value: self values maxValue
		on: (aGraphicsContext paint: self color).
	self
		displayLabelAt:
			(self calculatePoint: self values lowerQuartile value - self minValue)
		value: self values lowerQuartile
		on: (aGraphicsContext paint: self color).
	self
		displayLabelAt:
			(self calculatePoint: self values upperQuartile value - self minValue)
		value: self values upperQuartile
		on: (aGraphicsContext paint: self color).
	self
		displayLabelAt: (self calculatePoint: self values median2 value - self minValue)
		value: self values median2
		on: (aGraphicsContext paint: self color)! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLengthForFont: self textStyle defaultFont! !

!ESBoxPlotLabelDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotatedLabels := false.
	^self! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^true! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self fontSize! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	labelRepresentation := aBlock.
	super labelRepresentation: aBlock! !

!ESBoxPlotLabelDecorator methodsFor: 'accessing' stamp: 'AndreHora 3/25/2011 17:06'!
values
"	^ #(minValue maxValue lowerQuartile upperQuartile median2) 
	collect:[:sel | self getOriginalValues perform: sel]"
	
	^(OrderedCollection new)
		add: self getOriginalValues minValue;
		add: self getOriginalValues maxValue;
		add: self getOriginalValues lowerQuartile;
		add: self getOriginalValues upperQuartile;
		add: self getOriginalValues median2;
		yourself! !

ESAbstractAxisDecorator subclass: #ESFewBoxPlotBaseLineDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

ESFewBoxPlotBaseLineDecorator subclass: #ESBoxPlotBaseLineDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESBoxPlotBaseLineDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/11/2011 22:51'!
drawBaseLine: aGraphicsContext
	
	| rect1 rect2 translation translation2 min max width |
	aGraphicsContext paint: self color.
	width := 6.
	min := (self values minValue: [:each | each value]) - self minValue.
	max := (self values maximumValue: [:each | each]) - self minValue.
	aGraphicsContext
		displayLineFrom: (self calculatePoint: min)
		to: (self calculatePoint: self values lowerQuartile value - self minValue).
	translation := self
		calculateNormalVectorAt: self end
		ofLenght: width / 2.0.
	translation := translation translatedby: self end negated.
	translation2 := self
		calculateNormalVectorAt: self end
		ofLenght: width / 2.0 negated.
	translation2 := translation2 translatedby: self end negated.
	rect1 := Rectangle
		origin:
			((self calculatePoint: self values lowerQuartile value - self minValue)
				translatedby: translation)
		corner:
			((self calculatePoint: self values median2 value - self minValue) translatedby:
					translation2).
	rect2 := Rectangle
		origin:
			((self calculatePoint: self values median2 value - self minValue) translatedby:
					translation)
		corner:
			((self calculatePoint: self values upperQuartile value - self minValue)
				translatedby: translation2).
	aGraphicsContext
		displayLineFrom:
			(self calculatePoint: self values upperQuartile value - self minValue)
		to: (self calculatePoint: max).
	rect1 displayStrokedOn: aGraphicsContext.
	rect2 displayStrokedOn: aGraphicsContext! !

!ESBoxPlotBaseLineDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

!ESFewBoxPlotBaseLineDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self drawBaseLine: aGraphicsContext! !

!ESFewBoxPlotBaseLineDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/11/2011 22:51'!
drawBaseLine: aGraphicsContext
	
	| line1 line2 min max line3 line4 translation |
	min := (self values minValue: [:each | each]) - self minValue.
	max := (self values maximumValue: [:each | each]) - self minValue.
	line1 := LineSegment
		from: (self calculatePoint: min)
		to: (self calculatePoint: self values lowerQuartile).
	translation := self
		calculateNormalVectorAt: self end
		ofLenght: -1.
	translation := translation translatedby: self end negated.
	line2 := LineSegment
		from: (self calculatePoint: self values lowerQuartile)
		to: ((self calculatePoint: self values median2) scaledBy: 0.99).
	line2 := line2 translatedby: translation.
	line3 := LineSegment
		from: ((self calculatePoint: self values median2) scaledBy: 1.01)
		to: (self calculatePoint: self values upperQuartile).
	line3 := line3 translatedby: translation.
	line4 := LineSegment
		from: (self calculatePoint: self values upperQuartile)
		to: (self calculatePoint: max).
	line1 displayStrokedOn: (aGraphicsContext paint: self color).
	line2 displayStrokedOn: (aGraphicsContext paint: self color).
	line3 displayStrokedOn: (aGraphicsContext paint: self color).
	line4 displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESFewBoxPlotBaseLineDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

ESAbstractAxisDecorator subclass: #ESIdentifierDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESIdentifierDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/6/2011 23:06'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	"self halt."
	self values do: [:each | each displayOn: aGraphicsContext]! !

!ESIdentifierDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLengthForFont: self textStyle defaultFont! !

!ESIdentifierDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	labelRepresentation := [:each | each].
	centerIdentifiers := true.
	^self! !

!ESIdentifierDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^true! !

!ESIdentifierDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self fontSize! !

!ESIdentifierDecorator methodsFor: 'private' stamp: 'AndreHora 3/21/2011 11:32'!
setPositions
	
	| currPoint |
	self values
		doWithIndex:
			[:each :i | 
			self centerIdentifiers
				ifTrue:
					[currPoint := self end scaledBy: i - 0.5.
					currPoint := currPoint / self values size]
				ifFalse:
					[currPoint := self end scaledBy: i - 1.0.
					currPoint := currPoint / (self values size - 1)].
			each position: (self calculatePositionFor: each at: currPoint)]! !

ESAbstractAxisDecorator subclass: #ESRangeBaseLineDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESRangeBaseLineDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self drawBaseLine: aGraphicsContext! !

!ESRangeBaseLineDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/5/2011 11:39'!
drawBaseLine: aGraphicsContext
	
	| line min max |
	min := (self values minValue: [:each | each]) - self minValue.
	max := (self values maximumValue: [:each | each]) - self minValue.
	line := LineSegment
		from: (self calculatePoint: min)
		to: (self calculatePoint: max).
	line displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESRangeBaseLineDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

ESAbstractAxisDecorator subclass: #ESRangeLabelDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESRangeLabelDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/25/2011 17:30'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self
		displayLabelAt: (self calculatePoint: self values minValue value)
		value: self values minValue
		on: (aGraphicsContext paint: self color).
	self
		displayLabelAt: (self calculatePoint: self maxValue value)
		value: self maxValue
		on: (aGraphicsContext paint: self color)! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLength! !

!ESRangeLabelDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotatedLabels := false.
	^self! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^true! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	self fontSize isNil
		ifTrue: [^0]
		ifFalse: [^self fontSize]! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	labelRepresentation := aBlock.
	super labelRepresentation: aBlock! !

!ESRangeLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
values
	
	^(OrderedCollection new)
		add: self getOriginalValues minValue;
		add: self getOriginalValues maxValue;
		yourself! !

ESAbstractAxisDecorator subclass: #ESStackedValueDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESStackedValueDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/25/2011 17:33'!
displayOn: aGraphicsContext
	
	| offset |
	super displayOn: aGraphicsContext.
	offset := 0.
	self values
		do:
			[:each | 
			| currPoint |
			currPoint := offset + (each value / 2).
			self
				displayLabelAt: (self calculatePoint: currPoint)
				value: each
				on: (aGraphicsContext paint: self color).
			offset := offset + each value]! !

!ESStackedValueDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLengthForFont: self textStyle defaultFont! !

!ESStackedValueDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.	" *** Replace this comment with the appropriate initialization code *** "
	^self! !

!ESStackedValueDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self fontSize! !

!ESStackedValueDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESStackedValueDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	labelRepresentation := aBlock.
	super labelRepresentation: aBlock! !

ESAbstractAxisDecorator subclass: #ESTitleDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESTitleDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/28/2011 10:53'!
displayOn: aGraphicsContext
	
	| point |
	super displayOn: aGraphicsContext.
	point := self
		calculateNormalVectorAt: self end * 1.08
		ofLenght: "1 / 2 * (TextMeasurer defaultWidthOfString: self label) andre TODO"1.	" (self getDistanceToAxis: self label)/2"
	self label
		displayStringOn: (aGraphicsContext paint: self color)
		at: point! !

!ESTitleDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotatedLabels := false.
	^self! !

ESAbstractAxisDecorator subclass: #ESValueLabelDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESValueLabelDecorator methodsFor: 'private' stamp: ' 11/3/11 16:41'!
choseNonOverlappingValues
	"Algorithm which selects only points which aren't too close together
	adjust minDistance to show more Labels"
	
	| chosenValues tempValues lastPoint maxPoint |
	chosenValues := Set new.
	chosenValues add: (self values minValue: [:each | each value]).
	chosenValues add: self maxValue.
	maxPoint := self calculatePoint: self maxValue.
	tempValues := (self values copy
		sort: [:each1 :each2 | each1 value > each2 value]) removeDuplicates.
	lastPoint := 0 asPoint.
	tempValues
		do:
			[:each | 
			| currPoint |
			currPoint := self calculatePoint: each value.
			((lastPoint dist: currPoint) abs > self minTickDistance
				and: [(currPoint dist: maxPoint) abs > self minTickDistance])
				ifTrue:
					[chosenValues add: each.
					lastPoint := currPoint]].
	^chosenValues! !

!ESValueLabelDecorator methodsFor: 'displaying' stamp: 'AndreHora 4/6/2011 22:11'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self choseNonOverlappingValues
		do:
			[:each | 
			| currPoint |
			each value - self minValue = 0
				ifTrue: [currPoint := self calculatePoint: 0.001]
				ifFalse: [currPoint := self calculatePoint: each value - self minValue].
			self
				displayLabelAt: currPoint
				value: each
				on: (aGraphicsContext paint: self color)]! !

!ESValueLabelDecorator methodsFor: 'accessing' stamp: 'AndreHora 12/4/2011 18:44'!
getMaxLenghtOfLabel
	
	^ (self getOriginalValues collect: self labelRepresentation)
		getMaxStringLengthForFont: self textStyle defaultFont! !

!ESValueLabelDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	rotatedLabels := false.
	labelRepresentation := [:each | each printString].
	^self! !

!ESValueLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
isLabelDecorator
	
	^true! !

!ESValueLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelDistanceFromAxis
	
	^self fontSize! !

!ESValueLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation
	
	^labelRepresentation! !

!ESValueLabelDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
labelRepresentation: aBlock
	
	labelRepresentation := aBlock.
	super labelRepresentation: aBlock! !

ESAbstractAxisDecorator subclass: #ESValueTickDecorator
	instanceVariableNames: 'tickWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESValueTickDecorator methodsFor: 'displaying' stamp: ' 11/3/11 16:41'!
displayOn: aGraphicsContext
	
	super displayOn: aGraphicsContext.
	self values
		do:
			[:each | 
			self
				drawTickAt: (self calculatePoint: each value - self minValue)
				on: aGraphicsContext]! !

!ESValueTickDecorator methodsFor: 'displaying' stamp: 'AndreHora 3/28/2011 10:51'!
drawTickAt: aPoint on: aGraphicsContext
	
	| startPoint tick |
	startPoint := self
		calculateNormalVectorAt: aPoint
		ofLenght: self tickWidth.	"endPoint :=self calculateNormalVectorAt: aPoint ofLenght: self tickWidth/2 negated."
	tick := LineSegment from: startPoint to: aPoint.
	tick displayStrokedOn: (aGraphicsContext paint: self color)! !

!ESValueTickDecorator methodsFor: 'initialize-release' stamp: ' 11/3/11 16:41'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self tickWidth: 4.
	^self! !

!ESValueTickDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickWidth
	
	^tickWidth! !

!ESValueTickDecorator methodsFor: 'accessing' stamp: ' 11/3/11 16:41'!
tickWidth: anObject
	
	tickWidth := anObject! !

ESAbstractAxis subclass: #ESAxis
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeSee-Axis'!

!ESAxis methodsFor: 'displaying' stamp: 'AndreHora 3/28/2011 10:52'!
displayOn: aGraphicsContext
	
	"aGraphicsContext paint: Color black" "andre"
			
	"self label displayOn: (aDiagram graphicsContext paint: ColorValue lightGray) at: (self end scaledBy: 1.05).
	self displayStrokedOn: (aDiagram graphicsContext paint: ColorValue lightGray)."! !

!ESAxis methodsFor: 'initialize-release' stamp: 'AndreHora 3/11/2011 18:10'!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self minValue: 0.
	self maxValue: 0.
	self color: Color lightGray.
	^self! !
